package sk.kasv.collectionsOfStudents;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.Scanner;

public class Students {
    private List<String> list;

    public Students() {
        list  = new ArrayList<>();
    }

    private void menu(){
        System.out.println("Choose:  ");
        System.out.println("   1 - add new Student ");
        System.out.println("   2 - get count of Student ");
        System.out.println("   3 - get first student ");
        System.out.println("   4 - get last student ");
        System.out.println("   5 - get all students ");
        System.out.println("   6 - remove student ");
        System.out.println("   7 - add new student at position");
        System.out.println("   8 - find student based on name");
        System.out.println("   9 - exit");

    }

    private void newStudent(){
        Scanner sc = new Scanner(System.in);

        System.out.println("Please type a name of a new student.");
        String nameOfStudent = sc.nextLine();
        list.add(nameOfStudent);
        System.out.println("A new student " +nameOfStudent+ " has been created.");
    }

    private void printAllStudents(){
        System.out.println("List of students: ");
        /*for(int i = 0;i < list.size();i++) {
            System.out.println("  "+ list.get(i));
        }*/ //ALEBO

        for (String studentName : list){
            System.out.println(studentName);
        }
    }

    private void getFirstOrLastStudentName(String poradie){
        if(list.isEmpty()){
            System.out.println("Nenachadzaju sa tu žiadny študenti.");
        }else{

        }if(Objects.equals(poradie, "first")){
            for(int i = 0; i < list.size(); i++){
                if(i == 0)
                System.out.println("Prvý študent sa volá "+list.getFirst()+".");
            }
        } else if (Objects.equals(poradie, "last")) {
            for(int i = 0; i < list.size(); i++){
                if (i == list.size() - 1)
                System.out.println("Posledný študent sa volá "+list.getLast()+".");
            }
        }
    }

    private void removeStudent(){
            Scanner sc = new Scanner(System.in);
            System.out.print("Zadaj meno študenta ktorý sa vymaže ");
            String nameOfStudentToBeRemoved = sc.nextLine();

            if(list.contains(nameOfStudentToBeRemoved)){
                list.remove(nameOfStudentToBeRemoved);
                System.out.println("Študent menom " +nameOfStudentToBeRemoved+" bol vymazaný.");
            }else{
                System.out.println("Študent menom "+nameOfStudentToBeRemoved+" sa nenachádza v zozname.");
            }
    }

    private void findStudent(){
        Scanner sc = new Scanner(System.in);
        System.out.println("Meno hľadaného študenta: ");
        String nameOfStudent = sc.nextLine();

        if(list.contains(nameOfStudent)){
            int possition = list.indexOf(nameOfStudent);

            System.out.println("žiak " +nameOfStudent +" sa nachadza v zozname na pozicii "+(possition+1) +" .");

        }else{
            System.out.println("žiak sa nenachádza v zozname...");
        }

    }

    private void addStudentAtPossition(){
        Scanner sc = new Scanner(System.in);
        /*if(list.isEmpty()){
            System.out.println("Napíš meno študenta, avšak zoznam je prázdny, študent bude priradený na prvú pozíciu");
        }else {
            System.out.println("Napiš meno študenta a pozíciu na ktorú ho chceš pridať. (pozície sú dostupné od 1 do " + list.size() +" )");
        }*/
        System.out.println("Napíš meno študenta: ");
        String meno = sc.nextLine();
        if(list.isEmpty()){
            System.out.println("Študent bude priradený na prvú pozíciu, pretože zoznam je prázdny.");
            list.add(meno);
        }else{
            System.out.println("Napíš pozíciu na ktorú chceš priradiť študenta. ( 1 - " +list.size()+" )");
            int pozicia = sc.nextInt();
            if(pozicia == 1){
                list.addFirst(meno);
            }else{
                list.add(pozicia,meno);
            }

        }

            printAllStudents();



    }

    private void getCountOfStudents(){
        System.out.println("počet študentov je " +list.size()+".");
    }

    public void start(){
        menu();
        Scanner sc = new Scanner(System.in);
        while(true){
            System.out.println("Please, type a value [1-9]");
            int value = sc.next().charAt(0);

            switch (value){
                case '1' : newStudent(); break;
                case '2' : getCountOfStudents(); break;
                case '3' : getFirstOrLastStudentName("first");break;
                case '4' : getFirstOrLastStudentName("last");break;
                case '5' : printAllStudents();break;
                case '6' : removeStudent();break;
                case '7' : addStudentAtPossition();break;
                case '8' : findStudent();break;
                case '9': System.exit(0);
            }

            
        }
    }
}
